<?php

namespace OrganizationsManagement\Factory;

use Teknisa\Model\Teknisa\Entities\OmConfigColeta;
use Teknisa\Model\Util\NovoCodigo;

class ConfigColeta {

    /**
     * @param OmConfigColeta|null $omConfigColeta
     * @param string $idAtivo
     * @param $qtdDiasReaplicar
     * @param $dtLimite
     * @param $phpScriptLog
     * @param $nrproductoId
     * @param $currentUserId
     * @param $currentOrganizationId
     * @param $dateNow
     * @return mixed
     */
    public function save(OmConfigColeta $omConfigColeta = null, $idAtivo, $qtdDiasReaplicar, $dtLimite, $phpScriptLog, $nrproductoId, $currentUserId, $currentOrganizationId, $dateNow) {
        if(!$omConfigColeta) {
            $omConfigColeta = new OmConfigColeta();
            $novoCodigo = NovoCodigo::geraCodigo($currentOrganizationId, 'OM_CONFIG_COLETA', 1, 10, true);
            $omConfigColeta->setId($novoCodigo);
            $omConfigColeta->setDtinclusao($dateNow);
            $omConfigColeta->setNrorg($currentOrganizationId);
            $omConfigColeta->setCdoperinclusao($currentUserId);
            $omConfigColeta->setNrorginclusao($currentOrganizationId);
        }
        $omConfigColeta->setNrprodutoId($nrproductoId);
        $omConfigColeta->setIdativo($idAtivo);
        $omConfigColeta->setQtdDiasReaplicar($qtdDiasReaplicar);
        $omConfigColeta->setQtdDiasReaplicar($qtdDiasReaplicar);
        $omConfigColeta->setDtLimite($dtLimite);
        $omConfigColeta->setPhpScriptLog($phpScriptLog);
        $omConfigColeta->setDtultatu($dateNow);
        $omConfigColeta->setCdoperultatu($currentUserId);
        $omConfigColeta->setNrorgultatu($currentOrganizationId);

        return $omConfigColeta;
    }
}