<?php
namespace OrganizationsManagement\Factory;

use Teknisa\Model\Teknisa\Entities\OmClienteCustomizacao as EntidadeOmClienteCustomizacao;
use Teknisa\Libs\Util\Environment as TeknisaEnvironment;
use Setforms2\Shared\ORM\DateTime as SetformsDateTime;
use Teknisa\Model\Util\NovoCodigo as NovoCodigo;

class SMIntegration {
    /** @var TeknisaEnvironment **/
    protected $environment;

    public function __construct(TeknisaEnvironment $environment){
        $this->environment = $environment;
    }

    public function saveCliCustomizacao($cliente)
    {
        $dateNow      = new \DateTime();
        $currentOrgId = $this->environment->getCurrentOrganizationId();
        $cdOperador   = $this->environment->getCurrentUserId();

        $novoCodigo = NovoCodigo::geraCodigo($currentOrgId, "OM_CLIENTE_CUSTOMIZACAO", 1, 10, false, false);
        $cliCustom = new EntidadeOmClienteCustomizacao();
        $cliCustom->setId($novoCodigo);
        $cliCustom->setCdcliente($cliente);
        $cliCustom->setCdoperinclusao($cdOperador);
        $cliCustom->setNrorginclusao($currentOrgId);
        $cliCustom->setDtinclusao($dateNow);
        $cliCustom->setIdativo('S');
        $cliCustom->setNrorg($currentOrgId);

        return $cliCustom;

    }

}